import e, { createContext as q, useContext as G, useMemo as k, useCallback as h, useRef as z, useEffect as D, useState as T } from "react";
import { get as Y, set as $, clone as X } from "radash";
import { usePointerDrag as L } from "react-use-pointer-drag";
import { SketchPicker as K } from "react-color";
import Q from "filesize";
const B = q(void 0);
function N(a, o, s) {
  const c = G(B), r = k(() => (c == null ? void 0 : c.getValue(a)) ?? o, [c, a, o]), n = h((t) => {
    a && c && c.setValue(a, t), s == null || s(t);
  }, [a, c, s]);
  return [r, n];
}
const ae = ({ values: a, updateValues: o, onChange: s, onChangeValue: c, className: r, children: n }) => {
  const t = h((i) => i ? Y(a, i) : void 0, [a]), l = h((i, d) => {
    c == null || c(i, d);
    const E = $(X(a), i, d);
    o == null || o(E), s == null || s(E);
  }, [a, o, s, c]), u = k(() => ({ values: a, getValue: t, setValue: l }), [a, t, l]);
  return e.createElement(
    B.Provider,
    { value: u },
    e.createElement("div", { className: "react-var-ui " + (r || "") }, n)
  );
}, b = ({ label: a, children: o, className: s, disabled: c, column: r = !1 }) => e.createElement(
  "div",
  { className: "react-var-ui-label " + (a ? "react-var-ui-label-has-label " : "react-var-ui-label-no-label ") + (c ? "react-var-ui-disabled " : "") + (r ? "react-var-ui-label-column " : "") + (s || "") },
  !!a && e.createElement("span", null, a),
  o
), R = Math.PI * 2;
function U(a) {
  return (R + a % R) % R;
}
const ne = ({ label: a, path: o, value: s, onChange: c, disabled: r, defaultValue: n = 0, className: t }) => {
  const l = z(null), [u, i] = N(o, s, c), d = k(() => Math.round(U(u) * (180 / Math.PI)), [u]), { dragProps: E } = L({
    onMove: ({ x: m, y: v }) => {
      if (!l.current)
        return;
      const g = l.current.getBoundingClientRect(), y = g.left + g.width / 2, p = g.top + g.height / 2;
      i(U(Math.atan2(v - p, m - y) + Math.PI / 2));
    }
  });
  return D(() => {
    var m;
    (m = l.current) == null || m.addEventListener("wheel", (v) => v.preventDefault());
  }, []), e.createElement(
    b,
    { label: a, disabled: r, className: t, column: !0 },
    e.createElement(
      "span",
      { className: "react-var-ui-angle-value" },
      d,
      "°"
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-angle" },
      e.createElement("div", { className: "react-var-ui-angle-control", ref: l, style: { transform: `rotate(${d}deg)` }, onDoubleClick: () => typeof n < "u" && i(n), onWheel: (m) => {
        i(U(u + 0.5 * (m.deltaY < 0 ? -1 : 1)));
      }, title: "Angle", ...E() })
    )
  );
}, le = ({ path: a, value: o, onChange: s, disabled: c, className: r, children: n }) => {
  const [t, l] = N(a, o, s);
  return e.createElement("div", { className: "react-var-ui-array " + (c ? "react-var-ui-disabled " : "") + (r ?? "") }, t == null ? void 0 : t.map((u, i, d) => e.createElement(B.Provider, { value: {
    values: u,
    getValue: (E) => E ? Y(u, E) : void 0,
    setValue: (E, m) => {
      const v = [...t];
      v[i] = $(X(u), E, m), l(v);
    }
  }, key: i }, typeof n == "function" ? n(u, i, d) : n)));
}, ce = ({ label: a, onClick: o, buttonLabel: s, disabled: c, className: r }) => e.createElement(
  b,
  { label: a, disabled: c, className: r },
  e.createElement(
    "span",
    { className: "react-var-ui-button" },
    e.createElement("button", { onClick: () => o == null ? void 0 : o(), disabled: c }, s)
  )
), oe = ({ label: a, path: o, value: s, onChange: c, alpha: r, disabled: n, className: t }) => {
  const [l, u] = N(o, s, c), [i, d] = T(!1), E = h(() => d((v) => !v), [d]), m = h(() => d(!1), [d]);
  return e.createElement(
    b,
    { label: a, disabled: n, className: t },
    e.createElement(
      "span",
      null,
      e.createElement("span", { className: "react-var-ui-color-value" }, l),
      e.createElement(
        "div",
        { className: "react-var-ui-color" },
        e.createElement(
          "div",
          { className: "react-var-ui-color-swatch", onClick: E },
          e.createElement("div", { className: "react-var-ui-color-color", title: "Color preview", style: { background: l } })
        ),
        i ? e.createElement(
          "div",
          { className: "react-var-ui-color-popover" },
          e.createElement("div", { className: "react-var-ui-color-cover", onClick: m }),
          e.createElement(K, { color: l, onChange: (v) => {
            const f = v.hex === "transparent" ? "#000000" : v.hex;
            if (r) {
              let g = Math.round((v.rgb.a ?? 1) * 255).toString(16);
              g.length === 1 && (g = "0" + g), u(f + g);
            } else
              u(f);
          }, disableAlpha: !r })
        ) : null
      )
    )
  );
}, se = ({ label: a, path: o, value: s, disabled: c, className: r }) => {
  const [n] = N(o, s);
  return e.createElement(
    b,
    { label: a, disabled: c, className: r },
    e.createElement("span", null, n)
  );
}, A = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { d: "M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z" }),
  e.createElement("path", { d: "M7.646 1.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 2.707V11.5a.5.5 0 0 1-1 0V2.707L5.354 4.854a.5.5 0 1 1-.708-.708l3-3z" })
), ue = ({ label: a, path: o, value: s, onChange: c, disabled: r, className: n, accept: t, displayMetadata: l = !0 }) => {
  const [u, i] = N(o, s, c), d = h((E) => {
    var v;
    if (!((v = E.target.files) != null && v.length))
      return;
    const m = E.target.files[0];
    i(m);
  }, [i]);
  return e.createElement(
    b,
    { label: a, disabled: r, className: n, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-file" },
      l && !!u && e.createElement(
        "div",
        { className: "react-var-ui-file-metadata" },
        e.createElement(
          "div",
          null,
          "Name: ",
          e.createElement("span", null, u.name)
        ),
        e.createElement(
          "div",
          null,
          "Size: ",
          Q(u.size)
        ),
        e.createElement(
          "div",
          null,
          "Type: ",
          u.type || "unknown"
        )
      ),
      e.createElement(A, null),
      e.createElement("input", { type: "file", accept: t, onChange: d, title: "File upload" })
    )
  );
}, ie = ({ label: a, path: o, value: s, onChange: c, disabled: r, className: n }) => {
  const [t, l] = N(o, s, c), u = h((i) => {
    var m;
    if (!((m = i.target.files) != null && m.length))
      return;
    const d = i.target.files[0], E = URL.createObjectURL(d);
    l(E);
  }, [l]);
  return e.createElement(
    b,
    { label: a, disabled: r, className: n, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-image" },
      e.createElement("div", { className: "react-var-ui-image-background", style: {
        backgroundImage: t ? `url('${t}')` : void 0
      }, title: "Image preview" }),
      e.createElement(A, null),
      e.createElement("input", { type: "file", accept: "image/*", onChange: u, title: "Image upload" })
    )
  );
}, de = ({ label: a, path: o, value: s, onChange: c, disabled: r, className: n, acceptImage: t, acceptAudio: l, acceptVideo: u }) => {
  const [i, d] = N(o, s, c), [E, m] = T(), v = k(() => {
    let p = "";
    return t && (p += "image/*,"), l && (p += "audio/*,"), u && (p += "video/*,"), p.endsWith(",") && (p = p.slice(0, -1)), p || (p = "image/*,audio/*,video/*"), p;
  }, [t, l, u]), f = h((p) => {
    var M;
    if (!((M = p.target.files) != null && M.length))
      return;
    const V = p.target.files[0], C = URL.createObjectURL(V);
    d(C);
  }, [d, m]), g = h(async (p) => {
    var C, M, I;
    if (!p) {
      m(void 0);
      return;
    }
    const V = await fetch(p);
    m((I = (M = (C = V == null ? void 0 : V.headers) == null ? void 0 : C.get("Content-Type")) == null ? void 0 : M.split("/")) == null ? void 0 : I[0]);
  }, [m]);
  D(() => {
    g(i);
  }, [i]);
  let y = e.createElement("div", { className: "react-var-ui-media-metadata" }, i ? "Unsupported file type." : "");
  switch (E) {
    case "image":
      y = e.createElement("div", { className: "react-var-ui-media-background", style: {
        backgroundImage: `url('${i}')`
      }, title: "Media preview" });
      break;
    case "video":
      y = e.createElement("video", { className: "react-var-ui-media-background", muted: !0, loop: !0, autoPlay: !0, src: i, title: "Media preview" });
      break;
    case "audio":
      y = e.createElement("audio", { className: "react-var-ui-media-audio", loop: !0, controls: !0, src: i, title: "Media preview" });
      break;
  }
  return e.createElement(
    b,
    { label: a, disabled: r, className: n, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-media" },
      y,
      e.createElement(A, null),
      e.createElement("input", { type: "file", accept: v, onChange: f, title: "Media upload" })
    )
  );
};
function S(a, o, s, c, r) {
  var t;
  isFinite(a) || (a = o ?? 0);
  let n = 2;
  return typeof c == "number" && (n = ((t = c.toString().split(".")[1]) == null ? void 0 : t.length) || 0, n > 20 && (n = 20), a = Math.round(a / c) * c), typeof o == "number" && (a = Math.max(o, a)), typeof s == "number" && (a = Math.min(s, a)), r ? Math.round(a) : parseFloat(a.toFixed(n));
}
const J = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z" })
), W = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M7.646 4.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1-.708.708L8 5.707l-5.646 5.647a.5.5 0 0 1-.708-.708l6-6z" })
), me = ({ label: a, path: o, value: s, onChange: c, min: r, max: n, step: t = 1, integer: l, showButtons: u, disabled: i, className: d }) => {
  const [E, m] = N(o, s, c), v = k(() => S(E, r, n, t, !!l), [E, r, n, t, l]), f = h(() => m(S(E + (t ?? 1), r, n, t, !!l)), [E, m, l, r, n, t]), g = h(() => m(S(E - (t ?? 1), r, n, t, !!l)), [E, m, l, r, n, t]);
  return e.createElement(
    b,
    { label: a, disabled: i, className: d },
    e.createElement(
      "div",
      { className: "react-var-ui-number" },
      e.createElement("input", { className: "react-var-ui-number-input", type: "number", min: r, max: n, step: t, value: v.toString(), onChange: (y) => m(S(parseFloat(y.target.value), r, n, t, !!l)) }),
      u && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: f },
          e.createElement(W, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: g },
          e.createElement(J, null)
        )
      )
    )
  );
}, ve = ({ label: a, path: o, value: s, onChange: c, options: r, disabled: n, className: t }) => {
  const [l, u] = N(o, s, c), i = k(() => JSON.stringify(l), [l]);
  return e.createElement(
    b,
    { label: a, disabled: n, className: t },
    e.createElement(
      "div",
      { className: "react-var-ui-select" },
      e.createElement("select", { onChange: (d) => u(JSON.parse(d.target.value)), value: i, title: "Select options" }, r.map((d) => {
        const E = JSON.stringify(d.value ?? d.key);
        return e.createElement("option", { key: d.key, value: E }, d.label);
      }))
    )
  );
}, Ee = ({ label: a, path: o, value: s, onChange: c, min: r, max: n, step: t, integer: l, defaultValue: u, showInput: i, showButtons: d, disabled: E, className: m }) => {
  const v = z(null), [f, g] = N(o, s, c), y = k(() => S(f, r, n, t, !!l), [f, r, n, t, l]), p = k(() => (y - r) / (n - r) * 100, [y, r, n]), V = h((w) => {
    if (!v.current)
      return;
    const F = v.current.getBoundingClientRect(), j = (w - F.left) / F.width, H = S(r + (n - r) * j, r, n, t, !!l);
    g(H);
  }, [g, l, r, n, t]), C = h(() => g(S(f + t, r, n, t, !!l)), [f, g, l, r, n, t]), M = h(() => g(S(f - t, r, n, t, !!l)), [f, g, l, r, n, t]), { dragProps: I } = L({
    onMove: ({ x: w }) => V(w)
  });
  return D(() => {
    var w;
    (w = v.current) == null || w.addEventListener("wheel", (P) => P.preventDefault());
  }, []), e.createElement(
    b,
    { label: a, disabled: E, className: m },
    e.createElement(
      "div",
      { className: "react-var-ui-slider" },
      e.createElement(
        "div",
        { className: "react-var-ui-slider-track", ref: v, onClick: (w) => V(w.clientX), onDoubleClick: () => typeof u < "u" && g(u), onWheel: (w) => {
          w.deltaY < 0 ? C() : M();
        }, title: "Slider", ...I() },
        e.createElement("div", { className: "react-var-ui-slider-content", style: { width: p + "%" } })
      ),
      i ? e.createElement("input", { className: "react-var-ui-slider-input", type: "number", min: r, max: n, step: t, value: y, onChange: (w) => g(S(parseFloat(w.target.value), r, n, t, !!l)) }) : e.createElement("span", null, y.toString()),
      d && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: C },
          e.createElement(W, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: M },
          e.createElement(J, null)
        )
      )
    )
  );
}, ge = ({ label: a, path: o, value: s, onChange: c, maxLength: r, multiline: n, autoexpand: t, disabled: l, className: u }) => {
  const [i, d] = N(o, s, c), E = (v) => {
    const f = v.currentTarget;
    f.style.height = "0", f.style.height = `${f.scrollHeight}px`;
  }, m = k(() => t ? { overflow: "hidden", resize: "none" } : void 0, [t]);
  return e.createElement(b, { label: a, disabled: l, className: u, column: n }, n ? e.createElement("textarea", { className: "react-var-ui-string-multiline", value: i, onChange: (v) => d(v.target.value), onInput: t ? E : void 0, style: m }) : e.createElement(
    "span",
    { className: "react-var-ui-string" },
    e.createElement("input", { type: "text", maxLength: r, value: i, onChange: (v) => d(v.target.value) })
  ));
}, fe = ({ label: a, path: o, value: s, onChange: c, disabled: r, className: n }) => {
  const [t, l] = N(o, s, c);
  return e.createElement(
    b,
    { label: a, disabled: r, className: n },
    e.createElement(
      "span",
      null,
      e.createElement(
        "label",
        { className: "react-var-ui-toggle", title: "Toggle" },
        e.createElement("input", { type: "checkbox", checked: t, onChange: (u) => l(u.target.checked) }),
        e.createElement("span", { className: "react-var-ui-toggle-helper" })
      )
    )
  );
};
function O(a, o, s, c) {
  var n;
  const r = [0, 0];
  if (!a || !Array.isArray(a) || a.length < 2)
    return r;
  for (let t = 0; t < c.length; t++) {
    const l = ((n = c[t].toString().split(".")[1]) == null ? void 0 : n.length) || 0;
    r[t] = Math.round(a[t] / c[t]) * c[t], r[t] = Math.max(o[t], r[t]), r[t] = Math.min(s[t], r[t]), r[t] = parseFloat(r[t].toFixed(l));
  }
  return r;
}
function Z(a, o, s) {
  if (!a)
    return [50, 50];
  const c = [0, 0];
  for (let r = 0; r < a.length; r++)
    c[r] = (a[r] - o[r]) / (s[r] - o[r]) * 100;
  return c;
}
const pe = ({ label: a, path: o, value: s, onChange: c, disabled: r, className: n, defaultValue: t = [0, 0], min: l = [-1, -1], max: u = [1, 1], step: i = [0.01, 0.01] }) => {
  const d = z(null), [E, m] = N(o, s, c), v = k(() => O(E, l, u, i), [E, l, u, i]), f = k(() => Z(v, l, u), [v, l, u]), g = h((V, C) => {
    if (!d.current)
      return;
    const I = d.current.getBoundingClientRect(), w = (V - I.left) / I.width, P = (C - I.top) / I.height, F = O([
      l[0] + (u[0] - l[0]) * w,
      l[1] + (u[1] - l[1]) * P
    ], l, u, i);
    m(F);
  }, [m, l, u, i]), { dragProps: y } = L({
    onMove: ({ x: V, y: C }) => g(V, C)
  }), p = h(() => {
    typeof t < "u" && m(t);
  }, [t, m]);
  return e.createElement(
    b,
    { label: a, disabled: r, className: n, column: !0 },
    e.createElement(
      "span",
      { className: "react-var-ui-xy-value" },
      v[0],
      ", ",
      v[1]
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-xy" },
      e.createElement(
        "div",
        { className: "react-var-ui-xy-space", ref: d, onClick: (V) => g(V.clientX, V.clientY), onDoubleClick: p, ...y() },
        e.createElement("div", { className: "react-var-ui-xy-control", style: { top: f[1] + "%", left: f[0] + "%" } })
      )
    )
  );
}, he = ({ label: a, className: o, children: s }) => e.createElement(
  "div",
  { className: "react-var-ui-category " + (o || "") },
  e.createElement("div", { className: "react-var-ui-category-title" }, a),
  !!s && e.createElement("div", null, s)
);
export {
  ne as VarAngle,
  le as VarArray,
  b as VarBase,
  ce as VarButton,
  he as VarCategory,
  oe as VarColor,
  se as VarDisplay,
  ue as VarFile,
  ie as VarImage,
  de as VarMedia,
  me as VarNumber,
  ve as VarSelect,
  Ee as VarSlider,
  ge as VarString,
  fe as VarToggle,
  ae as VarUI,
  pe as VarXY,
  N as useVarUIValue
};
